Loading...
Searching...
No Matches
casacore::LELBinaryCmp< T > Class Template Reference
lattices package (libcasa_lattices) » LEL_module » LEL_module_internal_classes

This LEL class handles relational binary numerical operators. More...

`#include <LELBinary.h>`

## Public Member Functions

| LELBinaryCmp (const LELBinaryEnums::Operation op, const std::shared_ptr< LELInterface< T > > &pLeftExpr, const std::shared_ptr< LELInterface< T > > &pRightExpr)
| Constructor takes operation and left and right expressions to be operated upon.
| ~LELBinaryCmp ()
| Destructor.
virtual void | eval (LELArray< Bool > &result, const Slicer &section) const
| Recursively evaluate the expression.
virtual LELScalar< Bool > | getScalar () const
| Recursively evaluate the scalar expression.
virtual Bool | prepareScalarExpr ()
| Do further preparations (e.g.
virtual String | className () const
| Get class name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle locking/syncing of a lattice in a lattice expression.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
Public Member Functions inherited from casacore::LELInterface< Bool >
virtual | ~LELInterface ()
| Virtual destructor.
virtual void | evalRef (LELArrayRef< Bool > &result, const Slicer &section) const
LELArray< Bool > | getArray () const
| Get the result of an array subexpression.
Bool | isScalar () const
| Is the result of evaluating this expression a scalar ?
const IPosition & | shape () const
| Get the shape of the expression result.
const LELAttribute & | getAttribute () const
| Get expression attribute.

## Private Attributes

LELBinaryEnums::Operation | op_p
std::shared_ptr< LELInterface< T > > | pLeftExpr_p
std::shared_ptr< LELInterface< T > > | pRightExpr_p

## Additional Inherited Members

Static Public Member Functions inherited from casacore::LELInterface< Bool >
static Bool | replaceScalarExpr (std::shared_ptr< LELInterface< Bool > > &expr)
| If the given expression is a valid scalar, replace it by its result.
Protected Member Functions inherited from casacore::LELInterface< Bool >
void | setAttr (const LELAttribute &attrib)
| Set the expression attributes of this object.

## Detailed Description

template<class T>
class casacore::LELBinaryCmp< T >

This LEL class handles relational binary numerical operators.

### Intended use:

Internal

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Lattice
- LatticeExpr
- LatticeExprNode
- LELInterface
- LELBinaryEnums

### Etymology

This derived LEL letter class handles relational numerical binary operators

### Synopsis

This LEL letter class is derived from LELInterface. It is used to construct LEL objects that apply relational numerical binary operators to Lattice expressions. They operate on numerical (Float,Double,Complex,DComplex) Lattice expressions and result in a Bool. The available C++ operators are
==,!=>,>=,<,<=, with equivalents in the enum of EQ, NE, GT, GE, LT, and LE

A description of the implementation details of the LEL classes can be found in Note 216

### Example

Examples are not very useful as the user would never use these classes directly. Look in LatticeExprNode.cc to see how it invokes these classes. Examples of how the user would indirectly use this class (through the envelope) are:

IPosition shape(2,5,10);
ArrayLattice<Float> x(shape); x.set(1.0);
ArrayLattice<Float> y(shape); y.set(2.0);
ArrayLattice<Bool> z(shape);
z.copyData(x==y); // z = x == y;
z.copyData(x!=y); // z = x != y;
z.copyData(x>y); // z = x > y;
z.copyData(x>=y); // z = x >= y;
z.copyData(x<y); // z = x < y;
z.copyData(x<=y); // z = x <= y;
casacore::ArrayLattice
Definition ArrayLattice.h:144
casacore::IPosition
Definition IPosition.h:117
casacore::LELInterface< Bool >::shape
const IPosition & shape() const
Definition LELInterface.h:180

### Motivation

Numerical relational binary operations are a basic mathematical expression.

Definition at line 208 of file LELBinary.h.

## Constructor & Destructor Documentation

## LELBinaryCmp()

template<class T>

casacore::LELBinaryCmp< T >::LELBinaryCmp | ( | const LELBinaryEnums::Operation | op,
|  | const std::shared_ptr< LELInterface< T > > & | pLeftExpr,
|  | const std::shared_ptr< LELInterface< T > > & | pRightExpr )

Constructor takes operation and left and right expressions to be operated upon.

It can only handle the comparison operators.

## ~LELBinaryCmp()

template<class T>

casacore::LELBinaryCmp< T >::~LELBinaryCmp | ( |  | ) |

Destructor.

## Member Function Documentation

## className()

template<class T>

virtual String casacore::LELBinaryCmp< T >::className | ( |  | ) | const

virtual

Get class name.

Implements casacore::LELInterface< Bool >.

## eval()

template<class T>

virtual void casacore::LELBinaryCmp< T >::eval | ( | LELArray< Bool > & | result,
|  | const Slicer & | section ) const

virtual

Recursively evaluate the expression.

Implements casacore::LELInterface< Bool >.

## getScalar()

template<class T>

virtual LELScalar< Bool > casacore::LELBinaryCmp< T >::getScalar | ( |  | ) | const

virtual

Recursively evaluate the scalar expression.

Implements casacore::LELInterface< Bool >.

## hasLock()

template<class T>

virtual Bool casacore::LELBinaryCmp< T >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LELInterface< Bool >.

## lock()

template<class T>

virtual Bool casacore::LELBinaryCmp< T >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle locking/syncing of a lattice in a lattice expression.

Reimplemented from casacore::LELInterface< Bool >.

## prepareScalarExpr()

template<class T>

virtual Bool casacore::LELBinaryCmp< T >::prepareScalarExpr | ( |  | ) |

virtual

Do further preparations (e.g.

optimization) on the expression.

Implements casacore::LELInterface< Bool >.

## resync()

template<class T>

virtual void casacore::LELBinaryCmp< T >::resync | ( |  | ) |

virtual

Reimplemented from casacore::LELInterface< Bool >.

## unlock()

template<class T>

virtual void casacore::LELBinaryCmp< T >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LELInterface< Bool >.

## Member Data Documentation

## op_p

template<class T>

LELBinaryEnums::Operation casacore::LELBinaryCmp< T >::op_p

private

Definition at line 243 of file LELBinary.h.

## pLeftExpr_p

template<class T>

std::shared_ptr<LELInterface<T> > casacore::LELBinaryCmp< T >::pLeftExpr_p

private

Definition at line 244 of file LELBinary.h.

## pRightExpr_p

template<class T>

std::shared_ptr<LELInterface<T> > casacore::LELBinaryCmp< T >::pRightExpr_p

private

Definition at line 245 of file LELBinary.h.

The documentation for this class was generated from the following file:

- lattices/LEL/LELBinary.h